/*=========================================
 DotNetBips.ApplicationBlocks.Data
 Version 1.0
 Date: 19 October, 2002
 Author: Bipin Joshi (webmaster@dotnetbips.com)
=========================================*/

using System.Data;
using System.Configuration;
using System.Reflection;
using System;

public sealed class DataFactory
{

	public static  IDbConnection CreateConnection() 
	{
		Type t=null;
		Assembly a;
		a = Assembly.GetExecutingAssembly();
		AssemblyName[] b= a.GetReferencedAssemblies();
		foreach(AssemblyName obj in b)
		{
			if(obj.Name == ConfigurationSettings.AppSettings["assembly"])
			{																					
				Assembly an;
				an = Assembly.Load(obj.FullName);
				t = an.GetType(ConfigurationSettings.AppSettings["connection"]);
				break;
			}
		}
		return (IDbConnection)Activator.CreateInstance(t);
	}

	public static  IDbCommand CreateCommand()
	{
		Type t=null;
		Assembly a;
		a = Assembly.GetExecutingAssembly();
		AssemblyName[] b= a.GetReferencedAssemblies();
		foreach(AssemblyName obj in b)
		{
			if(obj.Name == ConfigurationSettings.AppSettings["assembly"])
			{
				Assembly an;
				an = Assembly.Load(obj.FullName);
				t = an.GetType(ConfigurationSettings.AppSettings["command"]);
				break;
			}
		}
		return (IDbCommand)Activator.CreateInstance(t);
	}

    public static  IDbDataAdapter CreateDataAdapter()
	{
        Type t=null;
        Assembly a;
        a = Assembly.GetExecutingAssembly();
        AssemblyName[] b = a.GetReferencedAssemblies();
        foreach(AssemblyName obj in b)
		{
			if(obj.Name == ConfigurationSettings.AppSettings["assembly"])
			{
				Assembly an;
				an = Assembly.Load(obj.FullName);
				t = an.GetType(ConfigurationSettings.AppSettings["dataadapter"]);
				break;
			}
		}
		return (IDbDataAdapter)Activator.CreateInstance(t);
   }

	public static  IDbDataParameter CreateParameter()
	{
		Type t=null;
		Assembly a;
		a = Assembly.GetExecutingAssembly();
		AssemblyName[] b = a.GetReferencedAssemblies();
		foreach(AssemblyName obj in b)
		{
			if(obj.Name == ConfigurationSettings.AppSettings["assembly"])
			{
				Assembly an;
				an = Assembly.Load(obj.FullName);
				t = an.GetType(ConfigurationSettings.AppSettings["parameter"]);
				break;
			}
		}
		return (IDbDataParameter)Activator.CreateInstance(t);
	}
}
